﻿//////////////////////////////////////////////
// EntityRenderInfoSlot.h
// 
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Entity ;
	class Mesh ;
}

/// Includes ---------------------------------

// nkGraphics
#include "../Dll/DllDefines.h"

#include "EntityRenderLodSlot.h"

// nkExport
#include <NilkinsExport/Exportable/Exportable.h>

// nkMemory
#include <NilkinsMemory/Containers/BufferCast.h>

/// Class ------------------------------------

namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT EntityRenderInfoSlot final : public nkExport::Exportable
	{
		friend class EntityRenderInfo ;

		private :

			// Attributes
			nkMemory::BufferCast<EntityRenderLodSlot*> _lods ;

			Entity* _parentEntity ;

		private :

			// Functions
			void _setParentEntity (Entity* entity) ;

		public :

			// Constructor, destructor
			EntityRenderInfoSlot () ;
			EntityRenderInfoSlot (const EntityRenderInfoSlot& other) ;
			EntityRenderInfoSlot (EntityRenderInfoSlot&& other) ;
			EntityRenderInfoSlot (Mesh* mesh, Shader* shader) ;
			~EntityRenderInfoSlot () ;

			// Getters
			EntityRenderLodSlot* getLod (unsigned int index) const ;
			const nkMemory::BufferCast<EntityRenderLodSlot*>& getLods () const ;
			Entity* getParentEntity () const ;

			// Manipulations
			EntityRenderLodSlot* addLod (const EntityRenderLodSlot& lodSlot = EntityRenderLodSlot()) ;
			void eraseLod (unsigned int index) ;

			// Operators
			EntityRenderInfoSlot& operator= (const EntityRenderInfoSlot& other) ;
			EntityRenderInfoSlot& operator= (EntityRenderInfoSlot&& other) ;

			// Import / Export
			virtual void exportClassToTree (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}