﻿//////////////////////////////////////////////
// Font.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkWinUi
#include "../Dll/DllDefines.h"

// nkMemory
#include <NilkinsMemory/Containers/String.h>
#include <NilkinsMemory/Containers/StringView.h>

/// Class ------------------------------------

namespace nkWinUi
{
	class DLL_WINUI_EXPORT Font
	{
		protected :

			// Settings
			nkMemory::String _name ;
			nkMemory::String _faceName ;
			unsigned int _size ;

			bool _default ;
			bool _readyForUse ;

		public :

			// Constructor, destructor
			Font () ;
			virtual ~Font () ;

			// Getters
			const nkMemory::String& getName () const ;
			const nkMemory::String& getFaceName () const ;
			unsigned int getSize () const ;
			bool getDefault () const ;
			bool getReadyForUse () const ;

			// Setters
			void setName (nkMemory::StringView value) ;
			void setFaceName (nkMemory::StringView value) ;
			void setSize (unsigned int value) ;
			void setDefault (bool value) ;

			// Loading
			virtual void load () = 0 ;
			virtual void unload () = 0 ;
			void reload () ;
	} ;
}